/[gentoo-x86]/eclass/leechcraft.eclass
Gentoo

Contents of /eclass/leechcraft.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.7 - (hide annotations) (download)
Sun Oct 14 12:19:32 2012 UTC (18 months ago) by pinkbyte
Branch: MAIN
Changes since 1.6: +22 -2 lines
Add compiler version checking for LeechCraft

1 vapier 1.5 # Copyright 1999-2012 Gentoo Foundation
2 maksbotan 1.1 # Distributed under the terms of the GNU General Public License v2
3 pinkbyte 1.7 # $Header: /var/cvsroot/gentoo-x86/eclass/leechcraft.eclass,v 1.6 2012/09/27 16:35:41 axs Exp $
4 maksbotan 1.1 #
5     # @ECLASS: leechcraft.eclass
6     # @MAINTAINER:
7 maksbotan 1.2 # leechcraft@gentoo.org
8 maksbotan 1.1 # @AUTHOR:
9     # 0xd34df00d@gmail.com
10     # NightNord@niifaq.ru
11 vapier 1.5 # @BLURB: Common functions and setup utilities for the LeechCraft app
12 maksbotan 1.1 # @DESCRIPTION:
13     # The leechcraft eclass contains a common set of functions and steps
14     # needed to build LeechCraft core or its plugins.
15     #
16     # Though this eclass seems to be small at the moment, it seems like a
17     # good idea to make all plugins inherit from it, since all plugins
18     # have mostly the same configuring/build process.
19     #
20     # Thanks for original eclass to Andrian Nord <NightNord@niifaq.ru>.
21     #
22     # Only EAPI >1 supported
23    
24     case ${EAPI:-0} in
25 axs 1.6 2|3|4|5) ;;
26 maksbotan 1.1 0|1) die "EAPI not supported, bug ebuild mantainer" ;;
27     *) die "Unknown EAPI, bug eclass maintainers" ;;
28     esac
29    
30 pinkbyte 1.7 inherit cmake-utils toolchain-funcs versionator
31 maksbotan 1.1
32     if [[ ${PV} == 9999 ]]; then
33     EGIT_REPO_URI="git://github.com/0xd34df00d/leechcraft.git"
34     EGIT_PROJECT="leechcraft"
35    
36     inherit git-2
37     else
38 maksbotan 1.3 local suffix
39     if version_is_at_least 0.4.95; then
40 maksbotan 1.4 DEPEND="app-arch/xz-utils"
41 maksbotan 1.3 suffix="xz"
42     else
43     suffix="bz2"
44     fi
45     SRC_URI="mirror://sourceforge/leechcraft/leechcraft-${PV}.tar.${suffix}"
46 maksbotan 1.1 S="${WORKDIR}/leechcraft-${PV}"
47     fi
48    
49     HOMEPAGE="http://leechcraft.org/"
50     LICENSE="GPL-3"
51    
52     # @ECLASS-VARIABLE: LEECHCRAFT_PLUGIN_CATEGORY
53     # @DEFAULT_UNSET
54     # @DESCRIPTION:
55     # Set this to the category of the plugin, if any.
56     : ${LEECHCRAFT_PLUGIN_CATEGORY:=}
57    
58     if [[ "${LEECHCRAFT_PLUGIN_CATEGORY}" ]]; then
59     CMAKE_USE_DIR="${S}"/src/plugins/${LEECHCRAFT_PLUGIN_CATEGORY}/${PN#leechcraft-}
60     elif [[ ${PN} != leechcraft-core ]]; then
61     CMAKE_USE_DIR="${S}"/src/plugins/${PN#leechcraft-}
62     else
63     CMAKE_USE_DIR="${S}"/src
64     fi
65 pinkbyte 1.7
66     EXPORT_FUNCTIONS "pkg_pretend"
67    
68     # @FUNCTION: leechcraft_pkg_pretend
69     # @DESCRIPTION:
70     # Determine active compiler version and refuse to build
71     # if it is not satisfied at least to minimal version,
72     # supported by upstream developers
73     leechcraft_pkg_pretend() {
74     debug-print-function ${FUNCNAME} "$@"
75    
76     if version_is_at_least 0.5.85; then
77     # 0.5.85 and later requires at least gcc 4.6
78     if [[ ${MERGE_TYPE} != binary ]]; then
79     [[ $(gcc-major-version) -lt 4 ]] || \
80     ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 6 ]] ) \
81     && die "Sorry, but gcc 4.6 or higher is required."
82     fi
83     fi
84     }

  ViewVC Help
Powered by ViewVC 1.1.20